﻿/**
 * @author kubaszek
 * GraphXYTrace - graph for mouse trace
 */
class graphXYTrace extends graph0 {

public var mcXYtrace :MovieClip = null;
public var mcLineX :MovieClip = null;
public var mcLineY :MovieClip = null;

public var mcXYPoint0 :MovieClip = null;
//mark point, when mouse click

private var tfX_val:TextField = null;
private var tfY_val:TextField = null;

public var nDepthXYtrace :Number = 0;
public var nDepthLineX :Number = 0;
public var nDepthLineY :Number = 0;
public var nDepthXYPoint0 :Number = 0;

public var nX_val:Number = 0;//x, y przeliczone na skalę nX_min..nX_max
public var nY_val:Number = 0;
public var tailNum :Number = 30;

private var nX_valClick:Number = NaN;//x, y zapamiętane dla kliknięcia
private var nY_valClick:Number = NaN;
private var nX_Click:Number = NaN;//Linx x, y zapamiętane dla kliknięcia
private var nY_Click:Number = NaN;

//zmienne globalne, bo nie umiem inaczej się odwołać w onChanged()
public static var nX_min :Number = 0.05;//h
public static var nX_max :Number = 0.9;
public static var nY_min :Number = 4;//N
public static var nY_max :Number = 64;

private var tailXY:Array = null;//new Array(new Array(/*x*/), new Array(/*y*/));

function graphXYTrace( target :MovieClip, depth :Number ){
	super(target, depth);
	this.tailXY = new Array(new Array(/*x*/), new Array(/*y*/));

	if ( this.nDepth < 0 ) this.nDepthXYtrace = -this.nDepth;
	else this.nDepthXYtrace = this.mcBckgrnd.getNextHighestDepth();
	this.nDepthLineX = 1+this.nDepthXYtrace;
	this.nDepthLineY = 1+this.nDepthLineX;
	this.nDepthXYPoint0 = 1+this.nDepthLineY;
	
	mcXYtrace =this.mcTarget.createEmptyMovieClip("mcXYtrace"+this.nDepthXYtrace, this.nDepthXYtrace);
	mcLineX =this.mcTarget.createEmptyMovieClip("mcLineX"+this.nDepthLineX, this.nDepthLineX);
	mcLineY =this.mcTarget.createEmptyMovieClip("mcLineY"+this.nDepthLineY, this.nDepthLineY);
	//trace("nDepthXYtrace= " + this.nDepthXYtrace+" nDepthLineX= "+this.nDepthLineX+" nDepthLineY= "+this.nDepthLineY, Log.INFO);

	mcXYPoint0 =this.mcTarget.createEmptyMovieClip("mcXYPoint0"+this.nDepthXYPoint0, this.nDepthXYPoint0);
}

public function drawBackground():Void{
	super.drawBackground();
	with ( mcLineX ) {
		lineStyle( 1, 0xff00ff, 100 );
		moveTo( this.nX1, this.nY1 );
		lineTo( this.nX1, this.nY1+this.nYh ); 
	}
	with ( mcLineY ) {
		lineStyle( 1, 0xff00ff, 100 );
		moveTo( this.nX1, this.nY1 );
		lineTo( this.nX1+this.nXw, this.nY1 ); 
	}
	
	with ( this.mcBckgrnd.tfX_label ) {
		//graph0.my_fmt.bold = true;
		//align = 'left';//default 
		graph0.my_fmt.bold = true;
		setNewTextFormat(graph0.my_fmt);
		//selectable = false;
		text = "h=";
		var mtr:Object = graph0.my_fmt.getTextExtent(text);
		
		this.mcBckgrnd.createTextField( "tfX_val", ++this.nDepth, 
			_x, _y, _width, _height );
			//_x+4+mtr.textFieldWidth, _y, _width-2*(4+mtr.textFieldWidth), _height );
	}
	with ( this.mcBckgrnd.tfX_val ) {
		//graph0.my_fmt.align = 'left';
		graph0.my_fmt.align = 'center';
		setNewTextFormat(graph0.my_fmt);
		selectable = false;
	}

	with ( this.mcBckgrnd.tfY_label ) {
		//graph0.my_fmt.align = 'center';
		//setNewTextFormat(graph0.my_fmt);
		_y -= _height/2;
		text = "N =";
		this.mcBckgrnd.createTextField( "tfY_val", ++this.nDepth, 
			_x, _y+_height+4, _width, _height );
	}
	with ( this.mcBckgrnd.tfY_val ) {
		//graph0.my_fmt.align = 'center';
		setNewTextFormat(graph0.my_fmt);
		selectable = false;
	}
	graph0.my_fmt.bold = false;
	graph0.my_fmt.align = 'left';

	this.mcBckgrnd.tfHeader.text =
		( (graph0.lang_Id == 1) ?
			"N: ilość próbek.; h: okres pr."
		:
			"N: sampl. num.; h: dt period" );
			
//śledzenie wartości tf._m.. w n._m..
	this.mcBckgrnd.tfX_min.text = graphXYTrace.nX_min;
	this.mcBckgrnd.tfX_max.text = graphXYTrace.nX_max;
	this.mcBckgrnd.tfY_min.text = graphXYTrace.nY_min;
	this.mcBckgrnd.tfY_max.text = graphXYTrace.nY_max;
	
	this.mcBckgrnd.tfX_min.onChanged = 
		function(tf_:TextField) {graphXYTrace.nX_min = parseFloat(tf_.text);};		
	this.mcBckgrnd.tfX_max.onChanged = 
		function(tf_:TextField) {graphXYTrace.nX_max = parseFloat(tf_.text);};		
	this.mcBckgrnd.tfY_min.onChanged = 
		function(tf_:TextField) {graphXYTrace.nY_min = parseFloat(tf_.text);};		
	this.mcBckgrnd.tfY_max.onChanged = 
		function(tf_:TextField) {graphXYTrace.nY_max = parseFloat(tf_.text);};		
}

public function redraw (xP :Number, yP :Number, shot :Boolean):Boolean {
//true if xP, yP inside or in the near, and differnt from previous

	if ( ! graph0.insideBox(xP, yP, 
			this.nX1-this.nMarginL, this.nY1-this.nMarginT, 
			this.nXw+2*this.nMarginL,//also nMarginL from right side 
			this.nYh+2*this.nMarginT) )
		return( false );

	if ( ( xP < this.nX1 ) || ( xP > this.nX1+this.nXw ) ) this.nX_val = NaN;
	else
		this.nX_val = 
			0 == ( graphXYTrace.nX_max - graphXYTrace.nX_min ) ? graphXYTrace.nX_min :
			( xP - this.nX1 ) / this.nXw
				* ( graphXYTrace.nX_max - graphXYTrace.nX_min ) + graphXYTrace.nX_min;
	if ( ( yP < this.nY1 ) || ( yP > this.nY1+this.nYh ) ) this.nY_val = NaN;
	else
		this.nY_val = 
			0 == ( graphXYTrace.nY_max - graphXYTrace.nY_min ) ? graphXYTrace.nY_min :
			( -yP + this.nY1+this.nYh ) / this.nYh
				* ( graphXYTrace.nY_max - graphXYTrace.nY_min ) + graphXYTrace.nY_min;

	this.mcBckgrnd.tfX_val.text = Math.round(this.nX_val*100)/100;
	this.mcBckgrnd.tfY_val.text = Math.round(this.nY_val);

	if ( shot )
		mcXYPoint0 =this.mcTarget.createEmptyMovieClip("mcXYPoint0"+this.nDepthXYPoint0, this.nDepthXYPoint0);
	
	if ( isNaN( this.nX_val ) || isNaN( this.nY_val ) ) {
		if ( shot ) {
			this.nX_valClick = NaN;
			this.nY_valClick = NaN;
		}
		else {
			if ( isNaN( this.nX_valClick ) || isNaN( this.nY_valClick ) ) { }
			else {
				this.mcBckgrnd.tfX_val.text = Math.round(this.nX_valClick*100)/100;
				this.mcBckgrnd.tfY_val.text = Math.round(this.nY_valClick);
				mcLineX._x = this.nX_Click;
				mcLineY._y = this.nY_Click;
			}
		}
		return( true );//clear polyline
	}
		
	if ( shot ) {
		this.nX_valClick = this.nX_val;
		this.nY_valClick = this.nY_val;
		this.nX_Click = xP - this.nX1; 
		this.nY_Click = yP - this.nY1; 
		
		with ( mcXYPoint0 ) {
			lineStyle( 7, 0x0402FC, 100 );
			moveTo( xP, yP );
			lineTo( xP+0.3, yP );
			lineStyle( 4, 0xffffff, 100 );
			lineTo( xP, yP );
		}
	}
	else
		if (( tailXY[0][0] == xP ) && ( tailXY[1][0] == yP )) return(false); 

	mcLineX._x = xP - this.nX1; 
	mcLineY._y = yP - this.nY1;
	
	tailXY[0][0]=xP; tailXY[1][0]=yP; 
	var i=tailNum;
	while (--i > 0) {
		tailXY[0][i]=tailXY[0][i-1];
		tailXY[1][i]=tailXY[1][i-1];
	}
	mcXYtrace =this.mcTarget.createEmptyMovieClip("mcXYtrace"+this.nDepthXYtrace, this.nDepthXYtrace);
	with ( mcXYtrace ) {
		i = 0;
		lineStyle( 2, 0xff00f0, 100 );
		moveTo( tailXY[0][0], tailXY[1][0] );
		while ( ++i < tailNum ) {
			lineTo( tailXY[0][i], tailXY[1][i] );
		}
	}
	return (true);
}	
	
}